Grouped Bar in JavaScript

Using ApexCharts with JavaScript

This Grouped Bar example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [
    {
      name: 'Spend',
      data: [18, 42, 55, 33, 21, 14, 9],
    },
    {
      name: 'Revenue',
      data: [64, 96, 138, 71, 52, 88, 130],
    },
  ],
  chart: {
    type: 'bar',
    height: 430,
  },
  plotOptions: {
    bar: {
      horizontal: true,
      dataLabels: {
        position: 'top',
      },
    },
  },
  dataLabels: {
    enabled: false,
  },
  stroke: {
    show: true,
    width: 1,
    colors: ['#fff'],
  },
  grid: {
    padding: {
      right: 30,
    },
  },
  tooltip: {
    shared: true,
    intersect: false,
  },
  title: {
    text: 'Marketing Spend vs Revenue by Channel',
    align: 'left',
  },
  xaxis: {
    categories: [
      'Email',
      'Social',
      'Search',
      'Display',
      'Affiliate',
      'Referral',
      'Direct',
    ],
    labels: {
      formatter: function (val) {
        return '$' + Math.round(val) + 'k'
      },
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Grouped Bar in Angular

Using ApexCharts with Angular

This Grouped Bar example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Spend',
              data: [18, 42, 55, 33, 21, 14, 9],
            },
            {
              name: 'Revenue',
              data: [64, 96, 138, 71, 52, 88, 130],
            },
          ],
          chart: {
            type: 'bar',
            height: 430,
          },
          plotOptions: {
            bar: {
              horizontal: true,
              dataLabels: {
                position: 'top',
              },
            },
          },
          dataLabels: {
            enabled: false,
          },
          stroke: {
            show: true,
            width: 1,
            colors: ['#fff'],
          },
          grid: {
            padding: {
              right: 30,
            },
          },
          tooltip: {
            shared: true,
            intersect: false,
          },
          title: {
            text: 'Marketing Spend vs Revenue by Channel',
            align: 'left',
          },
          xaxis: {
            categories: [
              'Email',
              'Social',
              'Search',
              'Display',
              'Affiliate',
              'Referral',
              'Direct',
            ],
            labels: {
              formatter: (val) => {
                return '$' + Math.round(val) + 'k'
              },
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Grouped Bar in Vue

Using ApexCharts with Vue

This Grouped Bar example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="bar"
        height="430"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Spend',
          data: [18, 42, 55, 33, 21, 14, 9],
        },
        {
          name: 'Revenue',
          data: [64, 96, 138, 71, 52, 88, 130],
        },
      ],
      chartOptions: {
        chart: {
          type: 'bar',
          height: 430,
        },
        plotOptions: {
          bar: {
            horizontal: true,
            dataLabels: {
              position: 'top',
            },
          },
        },
        dataLabels: {
          enabled: false,
        },
        stroke: {
          show: true,
          width: 1,
          colors: ['#fff'],
        },
        grid: {
          padding: {
            right: 30,
          },
        },
        tooltip: {
          shared: true,
          intersect: false,
        },
        title: {
          text: 'Marketing Spend vs Revenue by Channel',
          align: 'left',
        },
        xaxis: {
          categories: [
            'Email',
            'Social',
            'Search',
            'Display',
            'Affiliate',
            'Referral',
            'Direct',
          ],
          labels: {
            formatter: function (val) {
              return '$' + Math.round(val) + 'k'
            },
          },
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>

Grouped Bar in React

Using ApexCharts with React

This Grouped Bar example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Spend',
        data: [18, 42, 55, 33, 21, 14, 9],
      },
      {
        name: 'Revenue',
        data: [64, 96, 138, 71, 52, 88, 130],
      },
    ],
    options: {
      chart: {
        type: 'bar',
        height: 430,
      },
      plotOptions: {
        bar: {
          horizontal: true,
          dataLabels: {
            position: 'top',
          },
        },
      },
      dataLabels: {
        enabled: false,
      },
      stroke: {
        show: true,
        width: 1,
        colors: ['#fff'],
      },
      grid: {
        padding: {
          right: 30,
        },
      },
      tooltip: {
        shared: true,
        intersect: false,
      },
      title: {
        text: 'Marketing Spend vs Revenue by Channel',
        align: 'left',
      },
      xaxis: {
        categories: [
          'Email',
          'Social',
          'Search',
          'Display',
          'Affiliate',
          'Referral',
          'Direct',
        ],
        labels: {
          formatter: function (val) {
            return '$' + Math.round(val) + 'k'
          },
        },
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="bar"
          height={430}
        />
      </div>
    </div>
  )
}

export default ApexChart